// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SME2DBF.pas' rev: 3.00

#ifndef SME2DBFHPP
#define SME2DBFHPP
#include <SME2Cell.hpp>
#include <SMEEngine.hpp>
#include <ExportDS.hpp>
#include <Db.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Sme2dbf
{
//-- type declarations -------------------------------------------------------
#pragma pack(push, 1)
struct TDBFField
{
	char FieldName[11];
	char FieldType;
	int Address;
	Byte Length;
	Byte Decimals;
	Byte Reserved1[2];
	Byte WordAreaID;
	Word MultiUserDBase;
	Byte SetFields;
	Byte Reserved2[8];
	Byte MDXFlag;
} ;
#pragma pack(pop)

typedef TDBFField TDBFFields[256];

enum TDBFVersion { dBase3, dBase3Memo, FoxPro, FoxProMemo, dBase4, dBase4Memo, VFP3 };

enum TDBFMemoType { dmDBT, dmFPT };

#pragma pack(push, 1)
struct TDBFHeader
{
	Byte VersionNumber;
	Byte LastUpdateYear;
	Byte LastUpdateMonth;
	Byte LastUpdateDay;
	int NumberOfRecords;
	Word HeaderSize;
	Word RecordSize;
	char Reserve1[2];
	Byte IncompleteTransaction;
	Byte Encrypted;
	char Reserved[12];
	Byte MDXIsExist;
	Byte LanguageID;
	char Reserved2[2];
	int NumberOfFields;
	TDBFField Fields[256];
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct TSMEDBTHeader
{
	int NextBlock;
	Byte Dummy[4];
	Byte DbfFile[8];
	Byte Version;
	Byte Dummy2[3];
	Word BlockLen;
	Byte Dummy3[490];
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct TSMEFPTHeader
{
	int NextBlock;
	Byte Dummy[2];
	Word BlockLen;
	Byte Dummy3[504];
} ;
#pragma pack(pop)

struct TSMEBlockHeader;
typedef TSMEBlockHeader *PSMEBlockHeader;

struct TSMEBlockHeader
{
	int MemoType;
	int MemoSize;
} ;

class DELPHICLASS TSMExportToDBF;
class PASCALIMPLEMENTATION TSMExportToDBF : public Sme2cell::TSMExportToCellFile 
{
	typedef Sme2cell::TSMExportToCellFile inherited;
	
private:
	TDBFHeader DBFHeader;
	TSMEDBTHeader MEMOHeader;
	TDBFVersion FDBFVersion;
	TDBFMemoType FDBFMemoType;
	bool MemoIsExists;
	System::AnsiString MemoFileName;
	
protected:
	Classes::TStream* MEMOStream;
	virtual bool __fastcall MergeIsSupported(void);
	virtual void __fastcall InternalBeforeProcess(void);
	virtual void __fastcall InternalFileCreate(const System::AnsiString AFileName);
	void __fastcall WriteMemo(System::AnsiString Value);
	
public:
	virtual void __fastcall WriteDataBegin(void);
	virtual void __fastcall CloseFileStream(void);
	virtual void __fastcall WriteDimensions(int intRowCount, int intColCount);
	virtual void __fastcall WriteColWidth(int intCurColumn, int intColWidth);
	virtual void __fastcall WriteRowStart(bool IsAddedTitle);
	virtual void __fastcall WriteData(Db::TField* fld, Smeengine::TCellType CellType, int ARow, int ACol
		, System::AnsiString AString, Classes::TAlignment al, Graphics::TFont* font, Graphics::TColor color
		);
	__fastcall virtual TSMExportToDBF(Classes::TComponent* AOwner);
	virtual System::AnsiString __fastcall Extension();
	
__published:
	__property TDBFVersion DBFVersion = {read=FDBFVersion, write=FDBFVersion, default=0};
	__property TDBFMemoType DBFMemoType = {read=FDBFMemoType, write=FDBFMemoType, default=0};
public:
	/* TSMExportBaseComponent.Destroy */ __fastcall virtual ~TSMExportToDBF(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE Byte arrDBFVersion[7];

}	/* namespace Sme2dbf */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Sme2dbf;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SME2DBF
